import { mainRoutes, otherRoutes } from "@app/routing";
import { AppRouteDefinition } from "@app/types";
import { A, useLocation, useMatch } from "@solidjs/router";
import { animate, stagger, timeline } from "motion";
import { OverlayScrollbarsComponent } from "overlayscrollbars-solid";
import { Component, ComponentProps, For, Show, onMount } from "solid-js";
import { Motion, Presence } from "solid-motionone";
import Icon from "../Icon";
import RouteLabel from "./RouteLabel";

interface SideNavItemProps extends ComponentProps<"a"> {
  route: AppRouteDefinition;
}

const SideNavItem: Component<SideNavItemProps> = (props: SideNavItemProps) => {
  const match = useMatch(() => props.route.path);
  return (
    <A
      href={props.route.path}
      end={props.route.end}
      data-path={props.route.path}
      class="relative text-secondary-content w-full min-w-0 flex items-center gap-2 px-9 py-3 font-merienda"
    >
      <Presence exitBeforeEnter>
        <Show when={match()}>
          <Motion.div
            animate={{ opacity: [0, 1] }}
            exit={{ opacity: 0 }}
            transition={{ duration: 0.3 }}
            aria-hidden="true"
            class="absolute top-0 left-0 h-full w-full overflow-hidden"
            classList={{ "bg-secondary-shadow": !!match() }}
          >
            <Motion
              animate={{
                transform: [
                  "translate(-4px, 16px) scale(0.1)",
                  "translate(1px, -10px) scale(1)",
                ],
              }}
              transition={{ duration: 0.5 }}
              class="absolute bottom-0 -left-1.5"
            >
              <Icon
                icon="star"
                class="opacity-60 text-primary-shadow rotate-[15deg]"
              />
            </Motion>
            <Motion
              animate={{
                transform: [
                  "translate(-16px, 16px) scale(0.1)",
                  "translate(0px, 0px) scale(1)",
                ],
              }}
              transition={{ duration: 0.3 }}
              class="absolute -bottom-3 -left-3"
            >
              <Icon
                icon="star"
                class="opacity-60 text-white rotate-[-5deg] h-9 w-9"
              />
            </Motion>
            <Motion
              animate={{
                transform: ["translate(0px, 0px)", "translate(-16px, -28px)"],
              }}
              transition={{ duration: 0.5 }}
              class="absolute bottom-0 right-0"
            >
              <Icon
                icon="star"
                class="opacity-60 text-primary-shadow rotate-[15deg] w-2 h-2"
              />
            </Motion>
            <Motion
              animate={{
                opacity: [0, 1],
                transform: [
                  "translate(0px, 0px) scale(0.5)",
                  "translate(-2px, -12px) scale(1)",
                ],
              }}
              transition={{ duration: 0.5, delay: 0.3 }}
              class="absolute bottom-0 right-0"
            >
              <Icon
                icon="star"
                class="opacity-60 text-white rotate-[-5deg] h-5 w-5"
              />
            </Motion>
            <Motion
              animate={{
                transform: [
                  "translate(0px, 0px) scale(0.1)",
                  "translate(-24px, -15px) scale(1)",
                ],
              }}
              transition={{ duration: 0.5 }}
              class="absolute bottom-0 right-0"
            >
              <Icon
                icon="star"
                class="opacity-60 text-primary-shadow -rotate-[15deg] h-5 w-5"
              />
            </Motion>
            <Motion
              animate={{
                transform: [
                  "translate(200%, 200%) scale(0.1)",
                  "translate(-18px, 12px) scale(1)",
                ],
              }}
              transition={{ duration: 0.5 }}
              class="absolute bottom-0 right-0"
            >
              <Icon
                icon="star"
                class="opacity-60 text-white rotate-[8deg] h-8 w-8"
              />
            </Motion>
          </Motion.div>
        </Show>
      </Presence>
      <span class="relative w-8 h-8 rounded-full bg-secondary-darker"></span>
      <span class="relative capitalize select-none flex-1 min-w-0 text-ellipsis whitespace-nowrap overflow-hidden">
        <RouteLabel label={props.route.label} />
      </span>
    </A>
  );
};

const SideNav: Component = () => {
  let svgRef1!: SVGSVGElement;
  let svgRef2!: SVGSVGElement;
  const location = useLocation();

  const mainMenuRoutes = mainRoutes.filter(
    (r) => r.sideNav === undefined || r.sideNav
  );
  mainMenuRoutes.sort((a, b) => a.weight - b.weight);
  const otherMenuRoutes = otherRoutes.filter(
    (r) => r.sideNav === undefined || r.sideNav
  );
  otherMenuRoutes.sort((a, b) => a.weight - b.weight);

  onMount(() => {
    timeline([
      [
        [svgRef1, svgRef2],
        { opacity: [0, 1] },
        { duration: 0.4, delay: stagger(0.3) },
      ],
      [
        "#sidenav-cmp a",
        { opacity: [0, 1], transform: ["translateY(-50%)", "translateY(0)"] },
        { duration: 0.4, delay: stagger(0.1), at: "<" },
      ],
    ]);
  });

  const scrollTo = (container: HTMLElement, pathname: string) => {
    const element = container.querySelector<HTMLLIElement>(
      `.menu-others [data-path="${pathname}"]`
    );
    if (!element) return;
    const start = container.scrollTop;
    const end = Math.max(0, element.offsetTop);
    animate(
      (y) => {
        container.scrollTo({
          top: start + (end - start) * y,
        });
      },
      { duration: 1 }
    );
  };

  return (
    <section
      id="sidenav-cmp"
      class="relative z-10 w-full h-full bg-gradient-to-l from-secondary-shadow to-secondary"
    >
      <h1 class="sr-only">Navigation menu</h1>
      <OverlayScrollbarsComponent
        defer
        options={{ scrollbars: { autoHide: "leave", autoHideDelay: 0 } }}
        events={{
          initialized: (e) => {
            setTimeout(() => {
              scrollTo(e.elements().viewport, location.pathname);
            }, 500);
          },
        }}
        class="h-full"
      >
        <nav class="z-10 contents">
          <ul class="flex flex-col h-full gap-16">
            <li class="flex flex-1 flex-col relative pt-72">
              <svg
                ref={svgRef1}
                aria-hidden="true"
                class="w-[406px] absolute top-8 right-0"
                height="258"
                viewBox="0 0 389 256"
                fill="none"
                xmlns="http://www.w3.org/2000/svg"
              >
                <g opacity="0.2">
                  <path
                    fill-rule="evenodd"
                    clip-rule="evenodd"
                    d="M336.909 257.328C362.708 257.328 383.623 236.167 383.623 210.064C383.623 201.6 381.424 193.656 377.573 186.784C384.742 173.406 388.813 158.08 388.813 141.793C388.813 89.5863 346.984 47.2643 295.386 47.2643C284.475 47.2643 274.001 49.1568 264.267 52.635C252.78 21.8747 223.407 0 188.983 0C144.551 0 108.532 36.4439 108.532 81.3997C108.532 88.4077 109.408 95.2089 111.054 101.697C105.341 97.2043 98.1622 94.5287 90.366 94.5287C71.7332 94.5287 56.6285 109.812 56.6285 128.664C56.6285 129.548 56.6617 130.423 56.7268 131.29L38.3363 130.074C8.704 130.074 -16.0613 151.162 -22.3649 179.213C-36.2286 183.514 -46.5999 195.573 -49.1023 210.286C-58.4682 213.363 -65.0002 222.186 -65.0002 232.688C-65.0002 245.74 -55.5044 256.177 -42.6048 256.177L336.909 257.328Z"
                    fill="white"
                  />
                  <path
                    d="M103.342 76.1481C103.342 83.399 97.5323 89.2771 90.3659 89.2771C86.875 89.2771 83.7061 87.8824 81.3738 85.6136C79.9933 87.8156 77.5627 89.2771 74.7947 89.2771C70.4949 89.2771 67.0092 85.7503 67.0092 81.3997C67.0092 77.0491 70.4949 73.5223 74.7947 73.5223C75.7676 73.5223 76.6988 73.7029 77.5575 74.0327C78.5573 67.7876 83.9112 63.0191 90.3659 63.0191C97.5323 63.0191 103.342 68.8972 103.342 76.1481Z"
                    fill="white"
                  />
                  <mask
                    id="mask0_54_245"
                    style="mask-type:alpha"
                    maskUnits="userSpaceOnUse"
                    x="-66"
                    y="0"
                    width="455"
                    height="258"
                  >
                    <path
                      fill-rule="evenodd"
                      clip-rule="evenodd"
                      d="M336.909 257.328C362.708 257.328 383.623 236.167 383.623 210.064C383.623 201.6 381.424 193.656 377.573 186.784C384.742 173.406 388.813 158.08 388.813 141.793C388.813 89.5863 346.984 47.2643 295.386 47.2643C284.475 47.2643 274.001 49.1568 264.267 52.635C252.78 21.8747 223.407 0 188.983 0C144.551 0 108.532 36.4439 108.532 81.3997C108.532 88.4077 109.408 95.2089 111.054 101.697C105.341 97.2043 98.1622 94.5287 90.366 94.5287C71.7332 94.5287 56.6285 109.812 56.6285 128.664C56.6285 129.548 56.6617 130.423 56.7268 131.29L38.3363 130.074C8.704 130.074 -16.0613 151.162 -22.3649 179.213C-36.2286 183.514 -46.5999 195.573 -49.1023 210.286C-58.4682 213.363 -65.0002 222.186 -65.0002 232.688C-65.0002 245.74 -55.5044 256.177 -42.6048 256.177L336.909 257.328Z"
                      fill="white"
                    />
                    <path
                      d="M103.342 76.1481C103.342 83.399 97.5323 89.2771 90.3659 89.2771C86.875 89.2771 83.7061 87.8824 81.3738 85.6136C79.9933 87.8156 77.5627 89.2771 74.7947 89.2771C70.4949 89.2771 67.0092 85.7503 67.0092 81.3997C67.0092 77.0491 70.4949 73.5223 74.7947 73.5223C75.7676 73.5223 76.6988 73.7029 77.5575 74.0327C78.5573 67.7876 83.9112 63.0191 90.3659 63.0191C97.5323 63.0191 103.342 68.8972 103.342 76.1481Z"
                      fill="white"
                    />
                  </mask>
                  <g mask="url(#mask0_54_245)">
                    <path
                      d="M37.6693 178.165C50.9199 177.046 63.5719 180.02 74.3793 186.034C80.214 173.47 92.4369 164.302 107.229 163.053C109.355 162.873 111.456 162.864 113.519 163.014C113.765 150.602 123.358 140.133 136.001 139.065C149.513 137.925 161.39 147.953 162.531 161.464C163.469 172.571 156.858 182.575 146.97 186.416C148.778 190.43 149.947 194.814 150.339 199.451C152.192 221.406 135.897 240.707 113.941 242.561C111.777 242.744 109.639 242.75 107.541 242.592C107.471 275.671 82.0885 303.766 48.5123 306.601C25.0126 308.585 3.39544 297.697 -9.38801 279.807C-12.2413 280.628 -15.2164 281.183 -18.2873 281.442C-43.6206 283.581 -65.891 264.778 -68.0297 239.445C-70.1684 214.111 -51.3656 191.841 -26.0323 189.702C-16.8579 188.928 -8.08517 190.9 -0.524838 194.934C9.62981 185.586 22.8517 179.416 37.6693 178.165Z"
                      class="fill-secondary-darker"
                    />
                    <path
                      d="M20.652 173.632C20.3378 172.947 20.8658 172.174 21.6183 172.217L29.6624 172.679C29.9327 172.694 30.1978 172.599 30.397 172.416L36.3248 166.959C36.8793 166.448 37.7779 166.711 37.9693 167.44L40.0158 175.234C40.0846 175.495 40.2566 175.718 40.4926 175.851L47.5146 179.802C48.1715 180.172 48.1989 181.108 47.5647 181.515L40.7854 185.87C40.5575 186.016 40.3988 186.249 40.3454 186.514L38.7575 194.413C38.6089 195.152 37.7273 195.468 37.1439 194.99L30.9076 189.888C30.698 189.717 30.4278 189.638 30.1589 189.669L22.1554 190.6C21.4067 190.687 20.8345 189.946 21.1081 189.244L24.0332 181.736C24.1315 181.484 24.1233 181.202 24.0104 180.956L20.652 173.632Z"
                      class="fill-primary-shadow"
                    />
                    <path
                      d="M18.8447 179.772C18.5305 179.087 19.0585 178.314 19.811 178.357L32.5936 179.091C32.8639 179.107 33.129 179.012 33.3282 178.828L42.7478 170.156C43.3023 169.646 44.2009 169.909 44.3923 170.638L47.6443 183.022C47.7131 183.284 47.8851 183.507 48.1211 183.639L59.2795 189.918C59.9364 190.288 59.9638 191.224 59.3296 191.631L48.5568 198.551C48.329 198.697 48.1702 198.929 48.1169 199.195L45.5935 211.747C45.445 212.486 44.5634 212.802 43.98 212.324L34.0701 204.217C33.8605 204.046 33.5903 203.967 33.3213 203.998L20.6034 205.477C19.8547 205.564 19.2825 204.823 19.5561 204.121L24.2042 192.19C24.3025 191.938 24.2943 191.657 24.1814 191.411L18.8447 179.772Z"
                      class="fill-primary"
                    />
                    <circle cx="247" cy="154" r="37" fill="#355072" />
                    <path
                      d="M189.627 215.185C202.818 216.867 215.585 214.433 226.639 208.885C231.934 221.685 243.756 231.365 258.481 233.241C260.598 233.511 262.697 233.609 264.764 233.548C264.482 245.959 273.622 256.826 286.208 258.43C299.658 260.145 311.952 250.63 313.666 237.18C315.075 226.123 308.896 215.847 299.18 211.589C301.157 207.655 302.512 203.325 303.1 198.709C305.885 176.852 290.425 156.876 268.568 154.091C266.414 153.816 264.278 153.719 262.175 153.787C263.511 120.735 239.347 91.5865 205.921 87.3268C182.527 84.3455 160.467 94.304 146.934 111.634C144.118 110.693 141.17 110.012 138.112 109.622C112.893 106.408 89.8432 124.247 86.6293 149.467C83.4154 174.686 101.254 197.736 126.474 200.95C135.607 202.114 144.456 200.517 152.181 196.808C161.929 206.579 174.876 213.306 189.627 215.185Z"
                      class="fill-secondary-darker"
                    />
                    <path
                      d="M269.845 191.772C269.531 191.087 270.059 190.314 270.811 190.357L283.594 191.091C283.864 191.107 284.129 191.012 284.329 190.828L293.748 182.156C294.303 181.646 295.201 181.909 295.393 182.638L298.645 195.022C298.714 195.284 298.886 195.507 299.122 195.639L310.28 201.918C310.937 202.288 310.964 203.224 310.33 203.631L299.557 210.551C299.329 210.697 299.171 210.929 299.117 211.195L296.594 223.747C296.445 224.486 295.564 224.802 294.98 224.324L285.071 216.217C284.861 216.046 284.591 215.967 284.322 215.998L271.604 217.477C270.855 217.564 270.283 216.823 270.557 216.121L275.205 204.19C275.303 203.938 275.295 203.657 275.182 203.411L269.845 191.772Z"
                      class="fill-primary"
                    />
                    <path
                      fill-rule="evenodd"
                      clip-rule="evenodd"
                      d="M278.512 258.643C292.446 258.643 304.302 247.32 304.302 233.351C304.302 219.383 293.007 208.059 279.073 208.059C276.255 208.059 273.545 208.522 271.015 209.376C268.169 195.381 257.693 184.168 244.133 180.293C239.435 149.548 212.94 126 180.958 126C149.083 126 122.657 149.391 117.831 179.985C111.901 180.215 106.328 181.843 101.434 184.551C96.2158 180.274 89.5477 177.708 82.282 177.708C66.2962 177.708 53.2044 190.129 52.0843 205.868C48.3228 203.01 43.6343 201.314 38.5508 201.314C27.3287 201.314 18.0319 209.577 16.384 220.365C12.318 216.238 6.66994 213.679 0.426055 213.679C-11.9596 213.679 -22.0002 223.745 -22.0002 236.161C-22.0002 248.578 -11.9596 258.643 0.426055 258.643L278.512 258.643Z"
                      class="fill-secondary"
                    />
                    <path
                      d="M350.267 199.534C350.32 198.783 351.155 198.358 351.794 198.757L366.058 207.662C366.287 207.805 366.565 207.849 366.828 207.784L383.147 203.732C383.879 203.55 384.541 204.213 384.359 204.944L380.298 221.261C380.232 221.524 380.276 221.802 380.42 222.032L389.316 236.3C389.715 236.94 389.29 237.774 388.538 237.827L371.764 239.007C371.494 239.026 371.243 239.153 371.069 239.361L360.248 252.231C359.763 252.808 358.838 252.661 358.556 251.962L352.25 236.375C352.149 236.124 351.95 235.925 351.699 235.823L336.114 229.509C335.416 229.226 335.27 228.301 335.847 227.816L348.723 217.002C348.931 216.828 349.058 216.577 349.078 216.307L350.267 199.534Z"
                      class="fill-primary-shadow"
                    />
                    <path
                      d="M362.659 186.463C362.873 185.74 363.779 185.505 364.318 186.032L373.468 194.988C373.662 195.177 373.924 195.28 374.194 195.273L386.993 194.929C387.747 194.909 388.251 195.698 387.916 196.374L382.226 207.843C382.106 208.086 382.089 208.367 382.18 208.622L386.461 220.689C386.713 221.399 386.119 222.122 385.373 222.013L372.706 220.146C372.438 220.106 372.166 220.177 371.951 220.342L361.798 228.143C361.201 228.602 360.329 228.26 360.203 227.517L358.064 214.893C358.019 214.626 357.867 214.389 357.644 214.236L347.088 206.99C346.466 206.564 346.522 205.629 347.19 205.28L358.535 199.345C358.775 199.219 358.954 199.002 359.031 198.742L362.659 186.463Z"
                      class="fill-primary"
                    />
                  </g>
                </g>
              </svg>
              <ul class="flex flex-col mt-4">
                <For each={mainMenuRoutes}>
                  {(route) => (
                    <li>
                      <SideNavItem route={route} />
                    </li>
                  )}
                </For>
              </ul>
            </li>
            <li class="flex flex-col relative pt-48 pb-8">
              <svg
                ref={svgRef2}
                aria-hidden="true"
                class="w-[406px] absolute top-1 right-0"
                height="190"
                viewBox="0 0 342 190"
                fill="none"
                xmlns="http://www.w3.org/2000/svg"
              >
                <g opacity="0.2">
                  <g clip-path="url(#clip0_67_450)">
                    <path
                      d="M405.823 110.978C403.529 78.1334 376.83 52.2223 344.217 52.2223C338.061 52.2223 332.104 53.1556 326.499 54.8889C324.999 23.7111 299.425 -1.11108 268.092 -1.11108C243.048 -1.11108 221.667 14.7556 213.349 37.0667C199.139 24.3778 180.449 16.6667 159.973 16.6667C119.748 16.6667 86.4295 46.3556 80.4057 85.1556C72.7711 81.1556 64.1215 78.8889 54.9424 78.8889C24.36 78.8889 -0.441284 103.911 -0.441284 134.778C-0.441284 165.644 24.36 190.667 54.9424 190.667C57.833 190.667 60.6794 190.444 63.4596 190H328.772C366.172 187.267 395.762 165.622 403.793 136.667C404.257 134.978 407.302 123.444 405.823 110.978Z"
                      fill="white"
                    />
                  </g>
                  <mask
                    id="mask0_67_450"
                    style="mask-type:alpha"
                    maskUnits="userSpaceOnUse"
                    x="0"
                    y="0"
                    width="406"
                    height="190"
                  >
                    <g clip-path="url(#clip1_67_450)">
                      <path
                        d="M405.823 110.978C403.529 78.1334 376.83 52.2223 344.217 52.2223C338.061 52.2223 332.104 53.1556 326.499 54.8889C324.999 23.7111 299.425 -1.11108 268.092 -1.11108C243.048 -1.11108 221.667 14.7556 213.349 37.0667C199.139 24.3778 180.449 16.6667 159.973 16.6667C119.748 16.6667 86.4295 46.3556 80.4057 85.1556C72.7711 81.1556 64.1215 78.8889 54.9424 78.8889C24.36 78.8889 -0.441284 103.911 -0.441284 134.778C-0.441284 165.644 24.36 190.667 54.9424 190.667C57.833 190.667 60.6794 190.444 63.4596 190H328.772C366.172 187.267 395.762 165.622 403.793 136.667C404.257 134.978 407.302 123.444 405.823 110.978Z"
                        fill="white"
                      />
                    </g>
                  </mask>
                  <g mask="url(#mask0_67_450)">
                    <g clip-path="url(#clip2_67_450)">
                      <path
                        d="M259.51 92.3526C246.453 77.6178 225.964 73.4015 208.687 80.3183C207.554 77.4214 205.892 74.6771 203.71 72.2144C193.741 60.964 176.531 59.925 165.28 69.8943C154.03 79.8636 152.991 97.0733 162.96 108.324C167.655 113.621 173.945 116.65 180.471 117.341C179.078 129.666 182.718 142.519 191.594 152.535C208.215 171.291 236.886 173.022 255.643 156.402C274.399 139.781 276.13 111.109 259.51 92.3526Z"
                        fill="#355072"
                      />
                    </g>
                    <g clip-path="url(#clip3_67_450)">
                      <path
                        d="M317.948 176.826L329.566 176.081C331.026 175.733 342.766 172.708 347.183 161.874C349.483 156.221 348.715 151.095 348.442 149.406C347.012 140.605 341.068 135.453 338.845 133.525C337.137 132.044 333.632 129.069 328.179 127.726C326.359 127.278 324.464 127.042 322.515 127.036C322.39 126.707 322.274 126.384 322.15 126.055C319.587 122.592 316.034 119.944 311.952 118.464C308.002 106.199 296.147 97.7029 282.738 98.5632C272.678 99.2087 264.161 104.972 259.546 113.155C255.927 113.532 252.522 114.583 249.453 116.17C249.013 116.054 248.573 115.931 248.133 115.814C248.12 115.395 248.113 114.969 248.086 114.544C246.944 96.7511 231.64 83.2529 213.898 84.3912C208.499 84.7376 203.494 86.4077 199.182 89.0587C194.994 72.342 179.402 60.4589 161.64 61.5985C145.074 62.6615 131.833 74.7084 128.498 90.2079C128.074 90.125 127.644 90.0494 127.206 89.9742C121.269 87.2719 114.603 85.9515 107.645 86.3979C84.9966 87.8511 67.8209 107.439 69.2783 130.153C69.5466 134.334 70.4339 138.324 71.833 142.054C71.933 142.543 72.0061 142.827 72.0061 142.827C72.3092 143.592 72.6701 144.299 73.0622 144.955C74.1996 147.387 75.5546 149.681 77.1195 151.825C74.4406 152.32 70.7976 153.51 67.5323 156.418C60.3928 162.795 60.9962 172.198 61.158 174.721C61.344 177.62 61.8766 185.92 68.3203 190.09C71.4349 192.107 76.014 192.35 76.014 192.35L210.649 183.711"
                        class="fill-secondary-darker"
                      />
                    </g>
                    <path
                      d="M266.979 85.6708C267.245 84.9656 268.166 84.7971 268.665 85.3624L272.25 89.4277C272.429 89.6308 272.683 89.7526 272.953 89.7652L278.368 90.0179C279.121 90.053 279.566 90.8769 279.182 91.5257L276.424 96.1916C276.286 96.4247 276.248 96.7038 276.32 96.9649L277.753 102.192C277.952 102.919 277.306 103.597 276.57 103.433L271.28 102.251C271.016 102.192 270.739 102.243 270.513 102.391L265.984 105.37C265.354 105.784 264.51 105.379 264.439 104.628L263.928 99.2321C263.903 98.9626 263.769 98.7149 263.557 98.5456L259.326 95.1587C258.737 94.6877 258.861 93.7597 259.553 93.4603L264.527 91.3069C264.776 91.1993 264.97 90.9955 265.066 90.7422L266.979 85.6708Z"
                      class="fill-primary"
                    />
                    <g clip-path="url(#clip4_67_450)">
                      <path
                        d="M334.663 162.258H334.639C334.209 137.622 314.065 117.783 289.262 117.783C285.247 117.783 281.352 118.307 277.64 119.284C272.049 101.835 255.657 89.1913 236.294 89.1913C218.237 89.1913 202.76 100.183 196.213 115.821C186.727 107.172 174.094 101.899 160.227 101.899C132.651 101.899 109.967 122.754 107.155 149.511C104.128 151.131 101.253 152.855 98.5448 154.665C86.4378 159.526 76.9514 170.391 75.2389 183.336C75.1513 183.725 75.0716 184.106 74.9999 184.496C73.4706 193.097 74.9362 209.529 86.1511 218.646C91.7585 223.205 98.0908 224.547 102.081 225C135.798 224.738 169.522 224.468 203.238 224.206C259.082 225.032 300.15 225.103 313.157 225C315.865 224.976 322.086 224.865 329.087 221.823C330.585 221.172 339.251 217.288 344.221 209.91C354.161 195.162 347.956 168.532 334.663 162.258Z"
                        class="fill-secondary"
                      />
                    </g>
                    <path
                      d="M-10.5207 140.625C-10.9648 140.016 -10.6012 139.154 -9.85508 139.046L6.78855 136.653C7.05658 136.614 7.29752 136.469 7.45629 136.249L17.3152 122.628C17.7571 122.017 18.69 122.097 19.0226 122.773L26.4422 137.862C26.5617 138.105 26.7746 138.29 27.0323 138.373L43.0335 143.54C43.7508 143.771 43.9637 144.683 43.4232 145.209L31.3651 156.928C31.1709 157.117 31.0616 157.376 31.062 157.647L31.0925 174.462C31.0939 175.215 30.2925 175.7 29.6259 175.348L14.754 167.501C14.5145 167.375 14.234 167.351 13.9766 167.435L-2.00582 172.66C-2.72226 172.895 -3.43043 172.282 -3.30192 171.539L-0.435129 154.971C-0.388963 154.704 -0.452977 154.43 -0.612537 154.211L-10.5207 140.625Z"
                      class="fill-primary-shadow"
                    />
                    <path
                      d="M26.3151 120.981C26.959 120.589 27.7885 121.023 27.8332 121.776L28.3724 130.844C28.3884 131.114 28.5134 131.367 28.7188 131.543L35.6084 137.464C36.18 137.956 36.0233 138.879 35.3215 139.154L26.8635 142.469C26.6114 142.568 26.4101 142.764 26.3057 143.014L22.8033 151.396C22.5127 152.092 21.5864 152.228 21.1079 151.646L15.3414 144.626C15.1695 144.417 14.9201 144.286 14.6503 144.264L5.59604 143.523C4.8448 143.462 4.42904 142.623 4.83511 141.988L9.72922 134.334C9.87511 134.106 9.92224 133.829 9.85984 133.565L7.76646 124.725C7.59277 123.992 8.26216 123.337 8.99158 123.527L17.7828 125.817C18.0448 125.885 18.3234 125.844 18.5547 125.703L26.3151 120.981Z"
                      class="fill-primary"
                    />
                  </g>
                </g>
                <defs>
                  <clipPath id="clip0_67_450">
                    <rect width="406" height="190" fill="white" />
                  </clipPath>
                  <clipPath id="clip1_67_450">
                    <rect width="406" height="190" fill="white" />
                  </clipPath>
                  <clipPath id="clip2_67_450">
                    <rect
                      width="124.674"
                      height="90.7439"
                      fill="white"
                      transform="translate(206.916 33.0001) rotate(48.4549)"
                    />
                  </clipPath>
                  <clipPath id="clip3_67_450">
                    <rect
                      width="289"
                      height="125"
                      fill="white"
                      transform="translate(53.9999 68.5049) rotate(-3.6712)"
                    />
                  </clipPath>
                  <clipPath id="clip4_67_450">
                    <rect
                      width="274"
                      height="137"
                      fill="white"
                      transform="translate(74.9999 88)"
                    />
                  </clipPath>
                </defs>
              </svg>
              <ul class="menu-others flex flex-col mt-4">
                <For each={otherMenuRoutes}>
                  {(route) => (
                    <li>
                      <SideNavItem route={route} />
                    </li>
                  )}
                </For>
              </ul>
            </li>
          </ul>
        </nav>
      </OverlayScrollbarsComponent>
    </section>
  );
};

export default SideNav;
